package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T extends Object> {

    private T[] arr;

    public ArrayUtility(T[] arr){
        this.arr = arr;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        T[] newArr = merge(arr, arrayToMerge);
        Integer count = 0;
        for(int i = 0; i < newArr.length; i ++){
            if(newArr[i].equals(valueToEvaluate)){
                count ++;
            }
        }
        return count;
    }

    public T[] merge(T[] arr1, T[] arr2){
        T[] result = Arrays.copyOf(arr1, arr1.length + arr2.length);
        for(int i = 0; i < arr2.length; i ++){
            result[arr1.length + i] = arr2[i];
        }
        return result;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] newArr = merge(arr, arrayToMerge);
        Map<T, Integer> count = new HashMap<>();

        for(int i = 0; i < newArr.length; i ++){
            if(!count.containsKey(newArr[i])){
                count.put(newArr[i], 1);
            } else {
                Integer amount = count.get(newArr[i]);
                amount ++;
                count.put(newArr[i], amount);
            }
        }
        return countGreatestOccurMap(count);
    }

    public T countGreatestOccurMap(Map<T, Integer> map){
        int max = 0;
        T result = null;

        for(T key : map.keySet()){
            if(map.get(key) > max){
                max = map.get(key);
                result = key;
            }
        }
        return result;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        Map<T, Integer> count = new HashMap<>();

        for(int i = 0; i < arr.length; i ++){
            if(!count.containsKey(arr[i])){
                count.put(arr[i], 1);
            } else {
                Integer amount = count.get(arr[i]);
                amount ++;
                count.put(arr[i], amount);
            }
        }
        return count.get(valueToEvaluate);
    }

    public T[] removeValue(T valueToRemove) {
        Integer occ = getNumberOfOccurrences(valueToRemove);
        T[] newArr = (T[]) Array.newInstance(this.arr.getClass().getComponentType(), this.arr.length - occ );
        int count = 0;
        for(T elm : arr){
            if(elm.equals(valueToRemove)){
                continue;
            }else{
                newArr[count] = elm;
                count ++;
            }
        }
        return newArr;
    }
}
